<?php
/*
Plugin Name: NEX-Forms ADD ON - Form to Post
Plugin URI: http://codecanyon.net/item/nexforms-the-ultimate-wordpress-form-builder/7103891?ref=Basix
Description: Automatically create posts or pages from NEX-Forms form submissions. <strong>Requires at least: <a href="https://codecanyon.net/item/nexforms-the-ultimate-wordpress-form-builder/7103891?ref=Basix" target="_blank" style="display:block">NEX-Forms v7.x</a></strong>
Author: Basix
Version: 7.2
Author URI: http://codecanyon.net/user/Basix/portfolio?ref=Basix
License: GPL
*/
add_action( 'wp_ajax_nexforms_ftp_setup', 'nexforms_ftp_setup');
function nexforms_ftp_setup($form_Id){
	
	global $wpdb;
	
	$form_Id = (isset($_POST['form_Id'])) ? $_POST['form_Id'] : $form_Id;
	
	

	$form_to_post = 0;
	$raw_mapped_fields = 0;
	
	if($form_Id)
		{
		$get_form = $wpdb->prepare('SELECT * FROM '.$wpdb->prefix.'wap_nex_forms WHERE Id = %d ',filter_var($form_Id,FILTER_SANITIZE_NUMBER_INT));
		$form_attr = $wpdb->get_row($get_form);
		$raw_mapped_fields = explode('[end]',$form_attr->form_to_post_map);
		$form_to_post = $form_attr->is_form_to_post;
		}
	
	$ftp_field_map = array();
	if($raw_mapped_fields)
		{
		foreach($raw_mapped_fields as $raw_mapped_field)
			{
			$mapped_field_array = 	explode('[split]',$raw_mapped_field);
			if($mapped_field_array[0])
				$ftp_field_map[$mapped_field_array[0]] = $mapped_field_array[1];
			}
		}
	
	$output = '';
	
	echo '<div class="ftp_reponse_setup">';
											
		echo '<div class="row">';
			echo '<div class="col-sm-4">';
				echo 'Integrate with Form to Post';
			echo '</div>';
			echo '<div class="col-sm-8">';
			echo '
						
							<input id="ftp_intergrate_yes" class="with-gap" type="radio" value="1" '.(($form_to_post=='1') ? 'checked="checked"' : '').' name="ftp_integration">
							<label for="ftp_intergrate_yes">Yes</label>
						
							<input id="ftp_intergrate_no" class="with-gap" type="radio" value="0" '.(($form_to_post=='0') ? 'checked="checked"' : '').'  name="ftp_integration">
							<label for="ftp_intergrate_no">No</label>
						
			';
			echo '</div>';
		echo '</div>';
	
	$ftp_post_type 				= (isset($ftp_field_map['post_type'])) ? $ftp_field_map['post_type'] : 'post';
	$ftp_post_status 			= (isset($ftp_field_map['post_status'])) ? $ftp_field_map['post_status'] : 'pending';
	$ftp_comment_status 		= (isset($ftp_field_map['comment_status'])) ? $ftp_field_map['comment_status'] : 'open';
	$ftp_post_content	 		= (isset($ftp_field_map['post_content'])) ? $ftp_field_map['post_content'] : '';
	$ftp_post_title	 			= (isset($ftp_field_map['post_title'])) ? $ftp_field_map['post_title'] : '';
	$ftp_post_featured_image	= (isset($ftp_field_map['post_featured_image'])) ? $ftp_field_map['post_featured_image'] : '';
	
	
	
	

	echo '<h5>Field Map</h5>';

	/*$fields 	= $wpdb->get_results("SHOW FIELDS FROM " . $wpdb->prefix .'posts');
	if ($fields)
		{
		foreach($fields as $field)
			{
			if(
			$field->Field=='post_content' ||
			$field->Field=='post_title' )
				{
				echo '<div class="row ftp-form-field" data-field-tag="'.$field->Field.'">';
					echo '<div class="col-sm-4">';
						if($field->Field=='post_excerpt')
							echo 'Image Caption';
						else
							echo $field->Field;
					echo '</div>';
					echo '<div class="col-sm-8">';
						echo '<select name="ftp_current_fields" class="form-control" data-selected="'.$ftp_field_map[$field->Field].'">';
						echo '</select>';
					echo '</div>';
				echo '</div>';
				}
			}
		}
	else
		{
		echo '<div class="alert alert-danger">WP POST TABLE NOT FOUND.</div>';
		}*/
	
	
	echo '<div class="row ftp-form-field" data-field-tag="post_title">';
		echo '<div class="col-sm-4">';
					
				echo 'Post Title';
		echo '</div>';
		echo '<div class="col-sm-8">';
			echo '<select name="ftp_current_fields" class="form-control" data-selected="'.$ftp_post_title.'">';
			echo '</select>';
		echo '</div>';
	echo '</div>';
	
	
	echo '<div class="row ftp-form-field" data-field-tag="post_content">';
		echo '<div class="col-sm-4">';
					
				echo 'Post Content';
		echo '</div>';
		echo '<div class="col-sm-8">';
			//echo '<select name="ftp_current_fields" class="form-control" data-selected="'.$ftp_post_content.'">';
			//echo '</select>';
			
			wp_editor(str_replace('\\','',$ftp_post_content), 'ftp_content');
		echo '</div>';
	echo '</div>';
	
		

	echo '<div class="row ftp-form-field" data-field-tag="post_featured_image">';
		echo '<div class="col-sm-4">';
			echo 'Featured Image';
		echo '</div>';
		echo '<div class="col-sm-8">';
			echo '<select name="ftp_current_fields" class="form-control" data-selected="'.$ftp_post_featured_image.'">';
			echo '</select>';
		echo '</div>';
	echo '</div>';
	
	
	
	echo '<h5>Post/Page Attributes</h5>';
	echo '<div class="row ftp-attr" data-field-tag="post_type">';
					echo '<div class="col-sm-4">';
						echo 'Type';
					echo '</div>';
					echo '<div class="col-sm-8">';
						echo '<select name="ftp_attr_fields" class="form-control" data-selected="'.$ftp_post_type.'">';
							echo '<option value="post" '.(($ftp_post_type=='post') ? 'selected="selected"' : '').'>Post</option>';
							echo '<option value="page" '.(($ftp_post_type=='page') ? 'selected="selected"' : '').'>Page</option>';
						echo '</select>';
					echo '</div>';
				echo '</div>';
	
	echo '<div class="row ftp-attr" data-field-tag="post_status">';
					echo '<div class="col-sm-4">';
						echo 'After submit set post as:';
					echo '</div>';
					echo '<div class="col-sm-8">';
						echo '<select name="ftp_attr_fields" class="form-control" data-selected="'.$ftp_post_status.'">';
							echo '<option value="pending" '.(($ftp_post_status=='pending') ? 'selected="selected"' : '').'>Pending Review</option>';
							echo '<option value="publish" '.(($ftp_post_status=='publish') ? 'selected="selected"' : '').'>Published</option>';
							echo '<option value="draft" '.(($ftp_post_status=='draft') ? 'selected="selected"' : '').'>Draft</option>';
							echo '<option value="private" '.(($ftp_post_status=='private') ? 'selected="selected"' : '').'>Private</option>';
						echo '</select>';
					echo '</div>';
				echo '</div>';
	
	echo '<div class="row ftp-attr" data-field-tag="comment_status">';
					echo '<div class="col-sm-4">';
						echo 'Allow Comments';
					echo '</div>';
					echo '<div class="col-sm-8">';
						echo '<select name="ftp_attr_fields" class="form-control" data-selected="'.$ftp_comment_status.'">';
							echo '<option value="open" '.(($ftp_comment_status=='open') ? 'selected="selected"' : '').'>Open</option>';
							echo '<option value="closed" '.(($ftp_comment_status=='closed') ? 'selected="selected"' : '').'>Closed</option>';
						echo '</select>';
					echo '</div>';
				echo '</div>';
	
	
	echo '</div>';
	
	$ajax = (isset($_POST['form_Id'])) ? 1 : 0;
	
	if($ajax)
		{
		//echo $output; 
		die();
		}
	else
		return $output;
}

function nf_not_found_notice_ftp() {
    
		if(!function_exists('NEXForms_ui_output'))
			{
			?>
			<div class="error notice">
				<p><?php _e( '<strong>NEX-Forms not installed!</strong> You just installed <strong>Form to POST/PAGE Add-on for NEX-Forms</strong>. You need the NEX-Forms core plugin to run this add-on! Please get and install <a href="https://codecanyon.net/item/nexforms-the-ultimate-wordpress-form-builder/20947643?ref=Basix">NEX-Forms - The Ultimate WordPress Form Builder</a> to enable the features of this add-on.', 'my_plugin_textdomain' ); ?></p>
			</div>
			<?php
			}
		
}
add_action( 'admin_notices', 'nf_not_found_notice_ftp' );

